#!/usr/bin/env python
# -*- coding:utf-8 -*-

import ftplib
import urllib2
import sqlite3
import os
import codecs

blog_title = "Symfoware  "
blog_url = "http://symfoware.blog68.fc2.com/blog-entry-%d.html"
output_file = "sitemap.html"

#テンポラリDBの初期化
def init_db():
    
    tmp_db_name = 'fc2.db'
    do_create = False
    if not os.path.exists(tmp_db_name):
        do_create = True
    
    db=sqlite3.connect(tmp_db_name)
    
    if do_create:
        db.execute("create table fc2(id int,title text, primary key(id))")
    
    return db
    
def get_url_data(url):
    url = urllib2.urlopen(url)
    data = url.read()
    url.close()
    return data

def get_range(data,header,footer):
    
    pos = data.find(header)
    if pos == -1:
        return ""
    data = data[pos + len(header):]
    pos = data.find(footer)
    if pos == -1:
        return ""
        
    return data[:pos]
    
    
def get_blog_title(db):
    
    data = get_url_data('http://symfoware.blog68.fc2.com/?xml')
    hold_count = 0
    
    #RSSのデータから、最新記事のIDを取得する
    new_count = get_range(data,"blog-entry-",".html")
    
    #数値が取得できない場合は処理中断
    if not new_count.isdigit():
        return False
        
    new_count = int(new_count)
    
    #データベースに登録されているIDの最大値を取得する
    for row in db.execute("select max(id) as max_id from fc2"):
        if row[0]:
            hold_count = int(row[0]) + 1
            
    #更新されていない場合は処理を中断
    if new_count < hold_count:
        return False
    
    #データベースに登録されていない範囲のタイトルを取得し、
    #データベースに格納する
    for i in xrange(hold_count,int(new_count)+1):
        data = get_url_data(blog_url % i)
        #euc->utf変換
        title = unicode(get_range(data,"<title>","</title>"),'euc-jp') 
        #タイトルに必ずblog自身の名称が含まれるため、抜く
        title = title[len(blog_title):]
        #欠番IDの場合、タイトルが取得できないので、処理続行
        if not title:
            continue
        #取得したID、タイトルをデータベースに保存
        db.execute("insert into fc2 values (%d,'%s')" % (i,title))
    
    db.commit()
    return True
    
def make_sitemap(db):
    #データベースに登録されているデータのリンクを作成する
    f_header = codecs.open('header.txt','r','utf-8')
    f_footer = codecs.open('footer.txt','r','utf-8')
    
    f = codecs.open(output_file,'w','utf-8')
    
    f.write(f_header.read())
    
    for row in db.execute("select id,title from fc2"):
        f.write("<a href=\"%s\">%s</a><br />" % (blog_url % row[0],row[1]))
        f.write("\n")
    
    f.write(f_footer.read())
    
    f.close()
    f_header.close()
    f_footer.close()

def ftp_upload():
    ftp = ftplib.FTP('symfo.web.fc2.com','ftp_id','ftp_password')
    #パスワードも引数に取ったときは、login不要
    #ftp.login()
    #print ftp.retrlines('LIST')
    
    f = file(output_file, 'rb')
    ftp.cwd("blog/")
    ftp.storbinary("STOR " + output_file, f)
    ftp.close()
    f.close()

if __name__ == '__main__':
    #データベースの初期化
    db = init_db()
    
    #blgoのタイトル取得
    if get_blog_title(db):
        #サイトマップの作成
        make_sitemap(db)
        #FTPアップロード
        ftp_upload()